#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "types.h"

#define SCREEN_WIDTH    320
#define SCREEN_HEIGHT   200
#define TITLE           "Polygon_chap39"

SDL_Surface* scr;

/* 
================================================================
=
= Function: redraw
=
= Description:
=
= Updates the screen.  Has to be called to view new pixels, 
= but use only after drawing the whole screen because it's slow.
=
================================================================
*/
void redraw(void)
{
  SDL_UpdateRect(scr, 0, 0, 0, 0);
}

/* 
================================================================
=
= Function: cls
=
= Description:
=
= Clears the screen to black
=
================================================================
*/
void cls(void)
{
  SDL_FillRect(scr, NULL, 0);
}

/* 
================================================================
=
= Function: InitSDLScreenBuf
=
= Description:
=
= Try and get a handle to the screen buffer
=
================================================================
*/
U8 InitSDLScreenBuf(void)
{
    S32 Width = SCREEN_WIDTH;
    S32 Height = SCREEN_HEIGHT;
    S32 ColorDepth = 32;

     /* use SDL lib to get access to screen buffer */
    if(SDL_Init(SDL_INIT_EVERYTHING) < 0)
    {
        printf("Unable to init SDL: %s\n", SDL_GetError());
        SDL_Quit();
        return(1);
    }

    SDL_WM_SetCaption(TITLE, NULL);

    scr = SDL_SetVideoMode(Width, Height, ColorDepth, SDL_HWSURFACE | SDL_HWPALETTE);

    if(scr == NULL)
    {
        printf("Unable to set video: %s\n", SDL_GetError());
        SDL_Quit();
        return(1);
    }

    return(0);
}
